## openmesh 9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3.0 FATAL_ERROR)


# Set and enforce C++-11 flags
set( CMAKE_CXX_STANDARD_REQUIRED TRUE )
set( CMAKE_CXX_STANDARD 11 )

enable_testing()


project (OpenMesh 
         VERSION 9.0.0
         LANGUAGES C CXX ) 

# Set AUTO UIC/MOC Policy to new for CMAKE 3.17 or higher
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.17")
    cmake_policy(SET CMP0100 NEW)
endif()


if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "6.0" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "4.9" OR CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL "4.9")
		message(WARNING "Your version of GCC contains an optimizer bug. Please verify that you do not use -O3!")
		string(REPLACE "-O3" "-O2" CMAKE_CXX_FLAGS_RELEASE_NEW "${CMAKE_CXX_FLAGS_RELEASE}")
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE_NEW}" CACHE STRING "" FORCE)
	endif()
endif()

if ( WIN32 )
  # This is the base directory for windows library search used in the finders we ship.
  set(CMAKE_WINDOWS_LIBS_DIR "c:/libs" CACHE STRING "Default Library search dir on windows." )
endif()

if (NOT WIN32 AND NOT CMAKE_BUILD_TYPE)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# add our macro directory to cmake search path
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/cmake-library/finders ${CMAKE_CURRENT_SOURCE_DIR}/cmake-library/VCI )
set (CMAKE_DEBUG_POSTFIX "d")

# include our cmake files
include (VCICommon)

# Disable package building when built as an external library
if(${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
    include(OpenMeshPackage)
endif()

include (VCIOutput)
include(VCIQt)

# ========================================================================
# Definitions
# ========================================================================

if (WIN32)
  add_definitions(
      -D_USE_MATH_DEFINES -DNOMINMAX
      -D_CRT_SECURE_NO_WARNINGS
  )
endif ()

set(NO_DECREMENT_DEPRECATED_WARNINGS OFF CACHE BOOL "Disables all deprecated warnings warning about decrement operations on normal circulators.")
if(NO_DECREMENT_DEPRECATED_WARNINGS)
  add_definitions( -DNO_DECREMENT_DEPRECATED_WARNINGS )
endif()

# ========================================================================
# Windows build style control
# ========================================================================

if ( WIN32 )
  if ( NOT DEFINED OPENMESH_BUILD_SHARED )
    set( OPENMESH_BUILD_SHARED false CACHE BOOL "Build as shared library(DLL)?" )
  endif()
endif()

# ========================================================================
# Add bundle targets here
# ========================================================================
if ( NOT DEFINED BUILD_APPS )
  set( BUILD_APPS true CACHE BOOL "Enable or disable building of apps" )
endif()

# Only call fixbundle, when we are building OpenMesh standalone
if( (${CMAKE_PROJECT_NAME} MATCHES "OpenMesh") AND BUILD_APPS )

  if (WIN32)
    if ( NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" AND BUILD_APPS )
      add_custom_target (fixbundle ALL
        COMMAND ${CMAKE_COMMAND} -P "${CMAKE_BINARY_DIR}/fixbundle.win.cmake" )
    endif()
  endif()

  if (APPLE)
    add_custom_target (fixbundle ALL
      COMMAND ${CMAKE_COMMAND} -P "${CMAKE_BINARY_DIR}/fixbundle.cmake"
    )
  endif()

endif() # project OpenMesh

# ========================================================================
# Call the subdirectories with there projects
# ========================================================================

add_subdirectory (src/OpenMesh/Core)
add_subdirectory (src/OpenMesh/Tools)
add_subdirectory (src/OpenMesh/Apps)

set(OPENMESH_BENCHMARK_DIR CACHE PATH "Source path of benchmark (https://github.com/google/benchmark).")
if (OPENMESH_BENCHMARK_DIR)
	add_subdirectory(${OPENMESH_BENCHMARK_DIR} benchmark)
	add_subdirectory(src/Benchmark)
endif()

# Do not build unit tests when build as external library
if(${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
    add_subdirectory (src/Unittests)
else()
	# If built as a dependent project simulate effects of
	# successful finder run:
	set (OPENMESH_FOUND true PARENT_SCOPE)
	set (OPENMESH_LIBRARIES OpenMeshCore OpenMeshTools PARENT_SCOPE)
	set (OPENMESH_INCLUDE_DIR  "${CMAKE_CURRENT_SOURCE_DIR}/src" PARENT_SCOPE)
	set (OPENMESH_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/src" PARENT_SCOPE)

	# Also define variables provided by the old legacy finder.
	set (OPENMESH_CORE_LIBRARY OpenMeshCore PARENT_SCOPE)
	set (OPENMESH_TOOLS_LIBRARY OpenMeshTools PARENT_SCOPE)
	set (OPENMESH_TOOLS_LIBRARY OpenMeshTools PARENT_SCOPE)
	set (OPENMESH_LIBRARY OpenMeshCore OpenMeshTools PARENT_SCOPE)
	get_target_property(_OPENMESH_LIBRARY_DIR OpenMeshCore LIBRARY_OUTPUT_DIRECTORY)
	set (OPENMESH_LIBRARY_DIR "${_OPENMESH_LIBRARY_DIR}" CACHE PATH "The directory where the OpenMesh libraries can be found.")
endif()

if ( NOT DEFINED OPENMESH_DOCS )
  set( OPENMESH_DOCS true CACHE BOOL "Enable or disable building of documentation" )
endif()

if (OPENMESH_DOCS)
  add_subdirectory (Doc)
endif()

# ========================================================================
# Bundle generation (Targets exist, now configure them)
# ========================================================================

# Only call fixbundle, when we are building OpenMesh standalone
if(${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")

  if (WIN32 AND  BUILD_APPS)
    # prepare bundle generation cmake file and add a build target for it
    configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/cmake/fixbundle.cmake.win.in"
       "${CMAKE_CURRENT_BINARY_DIR}/fixbundle.win.cmake" @ONLY IMMEDIATE)

    if ( NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" )
      # let bundle generation depend on all targets
      add_dependencies (fixbundle QtViewer DecimaterGui)
    endif()
 
  endif()
 
  # On apple we do a fixbundle, which is only necessary for the apps and not for the libs
  if (APPLE AND BUILD_APPS)
    # prepare bundle generation cmake file and add a build target for it
    configure_file ("${CMAKE_SOURCE_DIR}/cmake/fixbundle.cmake.in"
       "${CMAKE_BINARY_DIR}/fixbundle.cmake" @ONLY IMMEDIATE)

    # let bundle generation depend on all targets
    if (QT_FOUND)
        add_dependencies (fixbundle DecimaterGui ProgViewer QtViewer SubdividerGui)
    endif()

    # Required for Snow leopard, and the latest qt. Then the resources have to be copied
    if ( EXISTS "/opt/local/libexec/qt4-mac/lib/QtGui.framework/Versions/4/Resources/qt_menu.nib" )
        add_custom_command(TARGET OpenMesh POST_BUILD
           COMMAND ${CMAKE_COMMAND} -E copy_directory "/opt/local/libexec/qt4-mac/lib/QtGui.framework/Versions/4/Resources/qt_menu.nib" 
                                                      "${CMAKE_BINARY_DIR}/Build/Libraries/qt_menu.nib" )
    endif ()
  endif ()

endif()

# ========================================================================

# Generate openmesh.pc file

set(DEST_DIR "${CMAKE_INSTALL_PREFIX}")
set(PRIVATE_LIBS "-lOpenMeshCore -lOpenMeshTools")

configure_file("openmesh.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/openmesh.pc" @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/openmesh.pc DESTINATION libdata/pkgconfig)

# generate target file

install(EXPORT OpenMeshConfig DESTINATION share/OpenMesh/cmake)

export(TARGETS OpenMeshCore OpenMeshTools FILE OpenMeshConfig.cmake)

# display results
vci_print_configure_header (OPENMESH "OpenMesh")

=== Doc/CMakeLists.txt ===
include (VCIDoxygen)

IF (DOXYGEN_FOUND)

  # Add a documentation install target
  vci_create_doc_target(doc-install)

  if (TARGET doc-install)
    vci_copy_after_build (doc-install "${CMAKE_BINARY_DIR}/Build/${VCI_PROJECT_DATADIR}/Doc/html"   "${CMAKE_INSTALL_PREFIX}/${VCI_PROJECT_DATADIR}/doc/html")
  endif()

ENDIF(DOXYGEN_FOUND)

=== Doc/Tutorial/CMakeLists.txt ===
include (VCICommon)

include_directories (
  ../../..
  ${CMAKE_CURRENT_SOURCE_DIR}
)

set (targetName MyOwnProject)

# collect all header and source files
vci_append_files (headers "*.hh" .)
vci_append_files (sources "*.cc" .)

vci_add_executable (${targetName} ${headers} ${sources})

target_link_libraries (${targetName}
  OpenMeshCore
  OpenMeshTools
)

=== src/Benchmark/CMakeLists.txt ===
set (SOURCES "")
list (APPEND SOURCES
	main.cpp
	VectorT_new.cpp
	VectorT_legacy.cpp
        VectorT_dummy_data.cpp
)

add_executable(OMBenchmark ${SOURCES})
set_target_properties(OMBenchmark PROPERTIES
	INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/..")
target_link_libraries(OMBenchmark benchmark OpenMeshCore)

=== src/Unittests/CMakeLists.txt ===
include (VCICommon)

include_directories (
  ..
  ${CMAKE_CURRENT_SOURCE_DIR}
)

if ( NOT DEFINED OPENMESH_BUILD_UNIT_TESTS)
    set( OPENMESH_BUILD_UNIT_TESTS false CACHE BOOL "Enable or disable unit test builds in OpenMesh." )
endif()

if ( OPENMESH_BUILD_UNIT_TESTS )
  # Search for gtest headers and libraries
  find_package(GTest)

  if(GTEST_FOUND)

    enable_testing()
   
    find_package(Eigen3)

    # Set correct include paths so that the compiler can find the headers
    include_directories(${GTEST_INCLUDE_DIRS} )


    # set additional link directories
    link_directories(${GTEST_LIBRARY_DIR} )

    
    if (TARGET Eigen3::Eigen)
      add_definitions( -DENABLE_EIGEN3_TEST ) 
      link_libraries(Eigen3::Eigen)
    else()
      message(WARNING "Eigen3 not found! This will skip the Eigen3 Unittests. You can point cmake to Eigen3 by setting Eigen3_DIR to the cmake files of Eigen3")
    endif()

    # Create new target named unittests_hexmeshing
    FILE(GLOB UNITTEST_SRC *.cc)
    # Create unittest executable
    vci_add_executable(unittests ${UNITTEST_SRC})
    vci_add_executable(unittests_customvec ${UNITTEST_SRC})
    vci_add_executable(unittests_doublevec ${UNITTEST_SRC})
    target_compile_definitions(unittests_customvec PRIVATE TEST_CUSTOM_TRAITS)
    target_compile_definitions(unittests_doublevec PRIVATE TEST_DOUBLE_TRAITS)
 
    # For the unittest we don't want the install rpath as set by vci_add_executable 
    set_target_properties ( unittests PROPERTIES  BUILD_WITH_INSTALL_RPATH 0 )
    set_target_properties ( unittests_customvec PROPERTIES  BUILD_WITH_INSTALL_RPATH 0 )
    set_target_properties ( unittests_doublevec PROPERTIES  BUILD_WITH_INSTALL_RPATH 0 )

   # Set output directory to ${BINARY_DIR}/Unittests
    set (OUTPUT_DIR "${CMAKE_BINARY_DIR}/Unittests")
      set_target_properties(unittests PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIR})
      set_target_properties(unittests_customvec PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIR})
      set_target_properties(unittests_doublevec PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIR})
      foreach(CONFIG ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${CONFIG} UPCONFIG)
        set_target_properties(unittests PROPERTIES RUNTIME_OUTPUT_DIRECTORY_${UPCONFIG} ${OUTPUT_DIR})
        set_target_properties(unittests_customvec PROPERTIES RUNTIME_OUTPUT_DIRECTORY_${UPCONFIG} ${OUTPUT_DIR})
        set_target_properties(unittests_doublevec PROPERTIES RUNTIME_OUTPUT_DIRECTORY_${UPCONFIG} ${OUTPUT_DIR})
    endforeach()

	
	if ( NOT WIN32)
           # Link against all necessary libraries
           target_link_libraries(unittests OpenMeshCore OpenMeshTools ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} pthread)
           target_link_libraries(unittests_customvec OpenMeshCore OpenMeshTools ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} pthread)
           target_link_libraries(unittests_doublevec OpenMeshCore OpenMeshTools ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} pthread)
	  
	  
	
       else()
	    # Link against all necessary libraries
		if ( OPENMESH_BUILD_SHARED )
			add_definitions( -DOPENMESHDLL )

		endif()
      target_link_libraries(unittests OpenMeshCore OpenMeshTools ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES})
      target_link_libraries(unittests_customvec OpenMeshCore OpenMeshTools ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES})
      target_link_libraries(unittests_doublevec OpenMeshCore OpenMeshTools ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES})
    endif()
	

    
	if ( NOT WIN32 )
	    # Set compiler flags
      set_target_properties(unittests PROPERTIES COMPILE_FLAGS "-g -pedantic -Wno-long-long")
      set_target_properties(unittests_customvec PROPERTIES COMPILE_FLAGS "-g -pedantic -Wno-long-long")
      set_target_properties(unittests_doublevec PROPERTIES COMPILE_FLAGS "-g -pedantic -Wno-long-long")
	else()
	    # Set compiler flags
      set_target_properties(unittests PROPERTIES COMPILE_FLAGS "" )
      set_target_properties(unittests_customvec PROPERTIES COMPILE_FLAGS "" )
      set_target_properties(unittests_doublevec PROPERTIES COMPILE_FLAGS "" )
    endif()
    
    if ( OPENMESH_BUILD_SHARED )
	
      #-------- copy dlls to unittests --------
      SET(OPENMESH_TARGETS "OpenMeshTools" "OpenMeshCore")
    
       foreach(TAR ${OPENMESH_TARGETS} )
         add_custom_command(TARGET unittests POST_BUILD 
                            COMMAND "${CMAKE_COMMAND}" -E copy 
                            "$<TARGET_FILE:${TAR}>"
                            "${CMAKE_BINARY_DIR}/Unittests/$<TARGET_FILE_NAME:${TAR}>" 
                            COMMENT "Copying OpenMesh targets to unittests directory")
         add_custom_command(TARGET unittests_customvec POST_BUILD
                            COMMAND "${CMAKE_COMMAND}" -E copy
                            "$<TARGET_FILE:${TAR}>"
                            "${CMAKE_BINARY_DIR}/Unittests/$<TARGET_FILE_NAME:${TAR}>"
                            COMMENT "Copying OpenMesh targets to unittests directory")
         add_custom_command(TARGET unittests_doublevec POST_BUILD
                            COMMAND "${CMAKE_COMMAND}" -E copy
                            "$<TARGET_FILE:${TAR}>"
                            "${CMAKE_BINARY_DIR}/Unittests/$<TARGET_FILE_NAME:${TAR}>"
                            COMMENT "Copying OpenMesh targets to unittests directory")
       endforeach(TAR)
     endif()
	
    vci_copy_after_build(unittests ${CMAKE_CURRENT_SOURCE_DIR}/TestFiles ${CMAKE_BINARY_DIR}/Unittests/)
    vci_copy_after_build(unittests_customvec ${CMAKE_CURRENT_SOURCE_DIR}/TestFiles ${CMAKE_BINARY_DIR}/Unittests/)
    vci_copy_after_build(unittests_doublevec ${CMAKE_CURRENT_SOURCE_DIR}/TestFiles ${CMAKE_BINARY_DIR}/Unittests/)

    add_test(NAME AllTestsIn_OpenMesh_tests WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/Unittests" COMMAND "${CMAKE_BINARY_DIR}/Unittests/unittests")
    add_test(NAME AllTestsIn_OpenMesh_tests_with_minimal_vector WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/Unittests" COMMAND "${CMAKE_BINARY_DIR}/Unittests/unittests_customvec")
    add_test(NAME AllTestsIn_OpenMesh_tests_with_double_vector WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/Unittests" COMMAND "${CMAKE_BINARY_DIR}/Unittests/unittests_doublevec")

  else(GTEST_FOUND)
      message(STATUS "Google testing framework was not found, unittests disabled.")
  endif(GTEST_FOUND)
endif()

=== cmake-library/CI/tests/CMakeLists.txt ===

file(GLOB tests 
    RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    CONFIGURE_DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/*")

foreach(test ${tests})
    if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${test}")
        message(STATUS "add_subdirectory(${test})")
        add_subdirectory("${test}")
    endif()
endforeach()


#[[==
maybe run configure/build as test?
cf https://cliutils.gitlab.io/modern-cmake/chapters/testing.html

add_test(
  NAME
    ExampleCMakeBuild
  COMMAND
    "${CMAKE_CTEST_COMMAND}"
             --build-and-test "${My_SOURCE_DIR}/examples/simple"
                              "${CMAKE_CURRENT_BINARY_DIR}/simple"
             --build-generator "${CMAKE_GENERATOR}"
             --test-command "${CMAKE_CTEST_COMMAND}"
)
==]]

=== src/OpenMesh/Apps/CMakeLists.txt ===
include (VCICommon)

if ( NOT DEFINED BUILD_APPS )
  set( BUILD_APPS true CACHE BOOL "Enable or disable building of apps" )
endif()
 
if ( BUILD_APPS )

  # Only build and fixbundle apps, when we are building OpenMesh standalone
  if(${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")

    if ( WIN32 AND OPENMESH_BUILD_SHARED )
	  add_definitions(-DOPENMESHDLL )
    endif()

    add_subdirectory (Dualizer)
    add_subdirectory (Decimating/commandlineDecimater)
    add_subdirectory (Smoothing)
    add_subdirectory (Subdivider/commandlineSubdivider)
    add_subdirectory (Subdivider/commandlineAdaptiveSubdivider)
    add_subdirectory (mconvert)
    add_subdirectory (VDProgMesh/mkbalancedpm)
    add_subdirectory (VDProgMesh/Analyzer)

    # Add non ui apps as dependency before fixbundle 
    if ( WIN32 )
      if ( NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" )
	# let bundle generation depend on all targets
	add_dependencies (fixbundle commandlineDecimater Dualizer mconvert Smoothing commandlineAdaptiveSubdivider commandlineSubdivider mkbalancedpm Analyzer )
      endif()
    endif()

    # Add non ui apps as dependency before fixbundle
    if ( APPLE)
      # let bundle generation depend on all targets
      add_dependencies (fixbundle commandlineDecimater Dualizer mconvert Smoothing commandlineAdaptiveSubdivider commandlineSubdivider mkbalancedpm Analyzer )
    endif()


    # find needed packages for gui applications
    find_package (OpenGL)

    # For the apps, we need qt and opengl to build them
    if (NOT QT_FOUND)
      set(QT_REQUIRED_PACKAGES
        Core
        Widgets
        OpenGL
        Gui
        )
      set(QT6_REQUIRED_PACKAGES
        OpenGLWidgets
        )
      vci_qt ()
      set(CMAKE_AUTOMOC ON)
    endif()

    if ("${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles")
      message(WARNING "GUI Apps are not build with mingw. (TODO)")
    endif()

    # check for OpenGL as our required dependencies
    if (( QT_FOUND ) AND OPENGL_FOUND AND NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" )

      add_subdirectory (Decimating/DecimaterGui)
      add_subdirectory (QtViewer)
      add_subdirectory (Subdivider/SubdividerGui)
      add_subdirectory (ProgViewer)
      add_subdirectory (VDProgMesh/Synthesizer)
			    

      # Add ui apps as dependency before fixbundle 
      if ( WIN32 AND NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles")
	# let bundle generation depend on all targets
	add_dependencies (fixbundle DecimaterGui ProgViewer QtViewer SubdividerGui Synthesizer)
      endif()
    
      # Add ui apps as dependency before fixbundle 
      if ( APPLE)
	# let bundle generation depend on all targets
	add_dependencies (fixbundle DecimaterGui ProgViewer QtViewer SubdividerGui Synthesizer)
      endif()

      if ( WIN32 )
	    FILE(GLOB files_install_app_dlls "${CMAKE_BINARY_DIR}/Build/*.dll" )
	    INSTALL(FILES ${files_install_app_dlls} DESTINATION . )

            # platform plugins for qt shoulb be installed along with the apps to run on the target systems
            if (EXISTS ${CMAKE_BINARY_DIR}/Build/plugins/platforms )
              FILE(GLOB files_install_app_platform_dlls "${CMAKE_BINARY_DIR}/Build/plugins/platforms/*.dll" )
              INSTALL(FILES ${files_install_app_platform_dlls} DESTINATION plugins/platforms/ )

              # Create a qt.conf file to find plugins on windows
              INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/Qt/qt.conf DESTINATION . )
            endif()

      endif()

    else () # QT ,Opengl or glut not found
      
      if (NOT QT_FOUND)
	    message ("QT not found! Skipping some apps.")
      endif ()

      if (NOT OPENGL_FOUND)
	    message ("OpengGL not found! Skipping some apps.")
      endif ()

    endif ()

  endif() # Project is OpenMesh standalone

else (BUILD_APPS)

  message ("Building Apps disabled by user.")

endif (BUILD_APPS)

=== src/OpenMesh/Core/CMakeLists.txt ===
include (VCICommon)

include_directories (
  ../..
  ${CMAKE_CURRENT_SOURCE_DIR}
)

# source code directories
set (directories 
  . 
  Geometry 
  IO 
  IO/exporter 
  IO/importer 
  IO/reader 
  IO/writer
  Mesh 
  Mesh/gen 
  System 
  Utils
)

# collect all header and source files
vci_append_files (headers "*.hh" ${directories})
vci_append_files (sources "*.cc" ${directories})

# Disable Library installation when not building OpenMesh on its own but as part of another project!
if ( NOT ${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
  set(VCI_NO_LIBRARY_INSTALL true)
endif()


if (WIN32)

  if ( OPENMESH_BUILD_SHARED )
    add_definitions( -DOPENMESHDLL -DBUILDOPENMESHDLL)
    vci_add_library (OpenMeshCore SHARED ${sources} ${headers})
  else()
    # OpenMesh has no dll exports so we have to build a static library on windows
    vci_add_library (OpenMeshCore STATIC ${sources} ${headers})
  endif()

else ()
  vci_add_library (OpenMeshCore SHAREDANDSTATIC ${sources} ${headers})
  set_target_properties (OpenMeshCore PROPERTIES VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
                                               SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR} )
endif ()

if (MSVC)
  target_compile_options(OpenMeshCore PUBLIC /bigobj)
endif ()

# Add core as dependency before fixbundle 
if ( (${CMAKE_PROJECT_NAME} MATCHES "OpenMesh") AND BUILD_APPS )

  if ( WIN32 )
    if ( NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" )
      add_dependencies (fixbundle OpenMeshCore)
    endif()
  endif()

  # Add core as dependency before fixbundle 
  if ( APPLE )
    # let bundle generation depend on targets
    add_dependencies (fixbundle OpenMeshCore)
  endif ()

endif()

# if we build debug and release in the same dir, we want to install both!
if ( ${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
  if ( WIN32 )
    FILE(GLOB files_install_libs "${CMAKE_BINARY_DIR}/Build/lib/*.lib" )
    FILE(GLOB files_install_dlls "${CMAKE_BINARY_DIR}/Build/*.dll" )
    INSTALL(FILES ${files_install_libs} DESTINATION lib )
    INSTALL(FILES ${files_install_dlls} DESTINATION . )
  endif()
endif()


# Install Header Files (Apple)
if ( NOT VCI_PROJECT_MACOS_BUNDLE AND APPLE )
 FILE(GLOB files_install_Geometry    "${CMAKE_CURRENT_SOURCE_DIR}/Geometry/*.hh" )
 FILE(GLOB files_install_IO          "${CMAKE_CURRENT_SOURCE_DIR}/IO/*.hh" "${CMAKE_CURRENT_SOURCE_DIR}/IO/*.inl"  )
 FILE(GLOB files_install_IO_importer "${CMAKE_CURRENT_SOURCE_DIR}/IO/importer/*.hh" )
 FILE(GLOB files_install_IO_exporter "${CMAKE_CURRENT_SOURCE_DIR}/IO/exporter/*.hh" )
 FILE(GLOB files_install_IO_reader   "${CMAKE_CURRENT_SOURCE_DIR}/IO/reader/*.hh" )
 FILE(GLOB files_install_IO_writer   "${CMAKE_CURRENT_SOURCE_DIR}/IO/writer/*.hh" )
 FILE(GLOB files_install_Mesh        "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/*.hh" )
 FILE(GLOB files_install_Mesh_Gen    "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/gen/*.hh" )
 FILE(GLOB files_install_System      "${CMAKE_CURRENT_SOURCE_DIR}/System/*.hh" "${CMAKE_CURRENT_SOURCE_DIR}/System/config.h" )
 FILE(GLOB files_install_Utils       "${CMAKE_CURRENT_SOURCE_DIR}/Utils/*.hh" )
 INSTALL(FILES ${files_install_Geometry}    DESTINATION include/OpenMesh/Core/Geometry )
 INSTALL(FILES ${files_install_IO}          DESTINATION include/OpenMesh/Core/IO )
 INSTALL(FILES ${files_install_IO_importer} DESTINATION include/OpenMesh/Core/IO/importer )
 INSTALL(FILES ${files_install_IO_exporter} DESTINATION include/OpenMesh/Core/IO/exporter )
 INSTALL(FILES ${files_install_IO_reader}   DESTINATION include/OpenMesh/Core/IO/reader )
 INSTALL(FILES ${files_install_IO_writer}   DESTINATION include/OpenMesh/Core/IO/writer )
 INSTALL(FILES ${files_install_Mesh}        DESTINATION include/OpenMesh/Core/Mesh )
 INSTALL(FILES ${files_install_Mesh_Gen}    DESTINATION include/OpenMesh/Core/Mesh/gen )
 INSTALL(FILES ${files_install_System}      DESTINATION include/OpenMesh/Core/System )
 INSTALL(FILES ${files_install_Utils}       DESTINATION include/OpenMesh/Core/Utils )
endif()


# Only install if the project name matches OpenMesh.
if (${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
  set (OPENMESH_NO_INSTALL_HEADERS FALSE CACHE BOOL "Should OpenMesh skip installing headers?")
else()
  set (OPENMESH_NO_INSTALL_HEADERS TRUE CACHE BOOL "Should OpenMesh skip installing headers?")
endif()

if (NOT APPLE AND NOT ${OPENMESH_NO_INSTALL_HEADERS})

# Install Header Files)
install(DIRECTORY . 
	DESTINATION include/OpenMesh/Core
        FILES_MATCHING 
	PATTERN "*.hh"
        PATTERN "CVS" EXCLUDE
        PATTERN ".svn" EXCLUDE
        PATTERN "tmp" EXCLUDE
	PATTERN "Templates" EXCLUDE
        PATTERN "Debian*" EXCLUDE)

#install the config file
install(FILES System/config.h DESTINATION include/OpenMesh/Core/System)

#install inlined Files from IO
install(DIRECTORY IO/ 
	DESTINATION include/OpenMesh/Core/IO
	FILES_MATCHING
	PATTERN "*.inl"         
	PATTERN "CVS" EXCLUDE
        PATTERN ".svn" EXCLUDE
        PATTERN "reader" EXCLUDE
        PATTERN "writer" EXCLUDE
        PATTERN "importer" EXCLUDE
        PATTERN "exporter" EXCLUDE
        PATTERN "tmp" EXCLUDE
        PATTERN "Debian*" EXCLUDE )    
endif ()

target_include_directories(OpenMeshCore PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
  $<INSTALL_INTERFACE:include>)

install(TARGETS OpenMeshCore EXPORT OpenMeshConfig
  ARCHIVE DESTINATION ${VCI_PROJECT_LIBDIR}
  LIBRARY DESTINATION ${VCI_PROJECT_LIBDIR}
  RUNTIME DESTINATION ${VCI_PROJECT_BINDIR})

=== src/OpenMesh/Tools/CMakeLists.txt ===
include (VCICommon)

include_directories (
  ../..
  ${CMAKE_CURRENT_SOURCE_DIR}
)

# source code directories
set (directories 
  . 
  Decimater
  Dualizer
  Smoother
  Subdivider/Adaptive/Composite
  Subdivider/Uniform/Composite 
  Subdivider/Uniform
  Utils
  VDPM
)

# collect all header and source files
vci_append_files (headers "*.hh" ${directories})
vci_append_files (sources "*.cc" ${directories})

IF(WIN32 AND NOT MINGW)
  vci_append_files (sources "*.c" ${directories})
ENDIF(WIN32 AND NOT MINGW)

# Disable Library installation when not building OpenMesh on its own but as part of another project!
if ( NOT ${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
  set(VCI_NO_LIBRARY_INSTALL true)
endif()


if (WIN32)

  if ( OPENMESH_BUILD_SHARED )
    add_definitions( -DOPENMESHDLL -DBUILDOPENMESHDLL)
    vci_add_library (OpenMeshTools SHARED ${sources} ${headers})
  else()
    # OpenMesh has no dll exports so we have to build a static library on windows
    vci_add_library (OpenMeshTools STATIC ${sources} ${headers})
  endif()

else ()
  vci_add_library (OpenMeshTools SHAREDANDSTATIC ${sources} ${headers})
  set_target_properties (OpenMeshTools PROPERTIES VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
                                                SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR} )
endif ()

target_link_libraries (OpenMeshTools OpenMeshCore)

IF( NOT WIN32 )
  target_link_libraries (OpenMeshToolsStatic OpenMeshCoreStatic)
ENDIF(NOT WIN32)

if ( (${CMAKE_PROJECT_NAME} MATCHES "OpenMesh") AND BUILD_APPS )

  if ( WIN32 )
    if ( NOT "${CMAKE_GENERATOR}" MATCHES "MinGW Makefiles" )
      # let bundle generation depend on target
      add_dependencies (fixbundle OpenMeshTools)
    endif()
  endif()

  # Add tools as dependency before fixbundle 
  if (APPLE)
    # let bundle generation depend on target
    add_dependencies (fixbundle OpenMeshTools)
    add_dependencies (fixbundle OpenMeshToolsStatic)
  endif()

endif()


# Install Header Files (Apple)
if ( NOT VCI_PROJECT_MACOS_BUNDLE AND APPLE )
 FILE(GLOB files_install_Decimater                       "${CMAKE_CURRENT_SOURCE_DIR}/Decimater/*.hh" )
 FILE(GLOB files_install_Dualizer                        "${CMAKE_CURRENT_SOURCE_DIR}/Dualizer/*.hh" )
 FILE(GLOB files_install_KERNEL_OSG                      "${CMAKE_CURRENT_SOURCE_DIR}/Kernel_OSG/*.hh" )
 FILE(GLOB files_install_Smoother                        "${CMAKE_CURRENT_SOURCE_DIR}/Smoother/*.hh" )
 FILE(GLOB files_install_Subdivider_Adaptive             "${CMAKE_CURRENT_SOURCE_DIR}/Subdivider/Adaptive/Composite/*.hh" )
 FILE(GLOB files_install_Subdivider_Uniform              "${CMAKE_CURRENT_SOURCE_DIR}/Subdivider/Uniform/*.hh" )
 FILE(GLOB files_install_Subdivider_Uniform_Composite    "${CMAKE_CURRENT_SOURCE_DIR}/Subdivider/Uniform/Composite/*.hh" )
 FILE(GLOB files_install_Utils                           "${CMAKE_CURRENT_SOURCE_DIR}/Utils/*.hh" "${CMAKE_CURRENT_SOURCE_DIR}/Utils/getopt.h" )
 FILE(GLOB files_install_VDPM                            "${CMAKE_CURRENT_SOURCE_DIR}/VDPM/*.hh" )
 INSTALL(FILES ${files_install_Decimater}                       DESTINATION include/OpenMesh/Tools/Decimater )
 INSTALL(FILES ${files_install_Dualizer}                        DESTINATION include/OpenMesh/Tools/Dualizer )
 INSTALL(FILES ${files_install_KERNEL_OSG}                      DESTINATION include/OpenMesh/Tools/Kernel_OSG )
 INSTALL(FILES ${files_install_Smoother}                        DESTINATION include/OpenMesh/Tools/Smoother )
 INSTALL(FILES ${files_install_Subdivider_Adaptive}             DESTINATION include/OpenMesh/Tools/Subdivider/Adaptive/Composite )
 INSTALL(FILES ${files_install_Subdivider_Uniform}              DESTINATION include/OpenMesh/Tools/Subdivider/Uniform )
 INSTALL(FILES ${files_install_Subdivider_Uniform_Composite}    DESTINATION include/OpenMesh/Tools/Subdivider/Uniform/Composite )
 INSTALL(FILES ${files_install_Utils}                           DESTINATION include/OpenMesh/Tools/Utils )
 INSTALL(FILES ${files_install_VDPM}                            DESTINATION include/OpenMesh/Tools/VDPM )
endif()


# Only install if the project name matches OpenMesh.
if (${CMAKE_PROJECT_NAME} MATCHES "OpenMesh")
  set (OPENMESH_NO_INSTALL_HEADERS FALSE CACHE BOOL "Should OpenMesh skip installing headers?")
else()
  set (OPENMESH_NO_INSTALL_HEADERS TRUE CACHE BOOL "Should OpenMesh skip installing headers?")
endif()

if (NOT APPLE AND NOT ${OPENMESH_NO_INSTALL_HEADERS})

# Install Header Files
install(DIRECTORY .
        DESTINATION include/OpenMesh/Tools
        FILES_MATCHING
        PATTERN "*.hh"
        PATTERN "CVS" EXCLUDE
        PATTERN ".svn" EXCLUDE
        PATTERN "tmp" EXCLUDE
        PATTERN "Templates" EXCLUDE
        PATTERN "Debian*" EXCLUDE)

#install the config file
install(FILES Utils/getopt.h DESTINATION include/OpenMesh/Tools/Utils)

endif ()

target_include_directories(OpenMeshTools PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
  $<INSTALL_INTERFACE:include>)

install(TARGETS OpenMeshTools EXPORT OpenMeshConfig
  ARCHIVE DESTINATION ${VCI_PROJECT_LIBDIR}
  LIBRARY DESTINATION ${VCI_PROJECT_LIBDIR}
  RUNTIME DESTINATION ${VCI_PROJECT_BINDIR})

=== cmake-library/CI/tests/GMM/CMakeLists.txt ===
find_package(GMM REQUIRED)

add_executable(test_gmm "test_gmm.cc")
target_link_libraries(test_gmm PRIVATE GMM::GMM)
add_test(NAME test_gmm COMMAND test_gmm)

=== cmake-library/CI/tests/Mosek/CMakeLists.txt ===
find_package(Mosek REQUIRED)

add_executable(mosek_c "mosek_c.c")
target_link_libraries(mosek_c Mosek::MosekC)
add_test(NAME mosek_c COMMAND mosek_c)

add_executable(mosek_cxx "mosek_cxx.cc")
target_link_libraries(mosek_cxx Mosek::FusionCXX)
add_test(NAME mosek_cxx COMMAND mosek_cxx)

=== src/OpenMesh/Apps/Dualizer/CMakeLists.txt ===
include (VCICommon)

include_directories (
  ../../..
)

vci_add_executable (Dualizer dualizer.cc)

target_link_libraries (Dualizer
  OpenMeshCore
  OpenMeshTools
)

=== debian/changelog ===
openmesh (9.0-4build3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:41:50 +0000

openmesh (9.0-4build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:41:44 +0000

openmesh (9.0-4build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:10:25 +0000

openmesh (9.0-4) unstable; urgency=medium

  * Added Build-Depends: ghostscript
  * Builds that target only arch:all work now

 -- Dima Kogan <dkogan@debian.org>  Sun, 06 Nov 2022 14:47:17 -0800

openmesh (9.0-3) unstable; urgency=medium

  * Added Build-Depends: graphviz

 -- Dima Kogan <dkogan@debian.org>  Fri, 04 Nov 2022 10:36:25 -0700

openmesh (9.0-2) unstable; urgency=medium

  * Source-only upload for migration

 -- Dima Kogan <dkogan@debian.org>  Tue, 01 Nov 2022 12:04:20 -0700

openmesh (9.0-1) unstable; urgency=medium

  * First release into Debian (Closes: #1015235)

 -- Dima Kogan <dkogan@debian.org>  Tue, 19 Jul 2022 15:22:27 -0700

=== debian/control ===
Source: openmesh
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libopengl-dev,
               freeglut3-dev,
               libqt5opengl5-dev
Build-Depends-Indep: doxygen,
                     texlive-latex-base,
                     texlive-latex-extra,
                     graphviz,
                     ghostscript
Standards-Version: 4.6.0
Homepage: http://www.openmesh.org
Vcs-Git: https://salsa.debian.org/science-team/openmesh.git
Vcs-Browser: https://salsa.debian.org/science-team/openmesh

Package: libopenmesh1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tools for representing and manipulating polygonal meshes
 OpenMesh is a generic and efficient data structure for representing and
 manipulating polygonal meshes. It was designed with the following goals in
 mind:
 .
 - Flexibility: provide a basis for many different algorithms without the need
 for adaptation.
 .
 - Efficiency: maximize time efficiency while keeping memory usage as low as
 possible.
 .
 - Ease of use: wrap complex internal structure in an easy-to-use interface.
 .
 OpenMesh provides the following features:
 .
 - Representation of arbitrary polygonal (the general case) and pure triangle
 meshes (providing more efficient, specialized algorithms)
 .
 - Explicit representation of vertices, halfedges, edges and faces.
 .
 - Fast neighborhood access, especially the one-ring neighborhood
 .
 - Highly customizable
 .
   - Choose your coordinate type (dimension and scalar type)
   - Attach user-defined elements/functions to the mesh elements.
   - Attach and check for attributes
   - Attach data at runtime using dynamic properties.
 .
 This package provides the shared library

Package: libopenmesh-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmesh1 (= ${binary:Version}),
         libeigen3-dev,
         libopenscenegraph-dev
Suggests: libopenmesh-doc, libopenmesh-apps
Description: Tools for representing and manipulating polygonal meshes
 OpenMesh is a generic and efficient data structure for representing and
 manipulating polygonal meshes. It was designed with the following goals in
 mind:
 .
 - Flexibility: provide a basis for many different algorithms without the need
 for adaptation.
 .
 - Efficiency: maximize time efficiency while keeping memory usage as low as
 possible.
 .
 - Ease of use: wrap complex internal structure in an easy-to-use interface.
 .
 OpenMesh provides the following features:
 .
 - Representation of arbitrary polygonal (the general case) and pure triangle
 meshes (providing more efficient, specialized algorithms)
 .
 - Explicit representation of vertices, halfedges, edges and faces.
 .
 - Fast neighborhood access, especially the one-ring neighborhood
 .
 - Highly customizable
 .
   - Choose your coordinate type (dimension and scalar type)
   - Attach user-defined elements/functions to the mesh elements.
   - Attach and check for attributes
   - Attach data at runtime using dynamic properties.
 .
 This package provides the development files library

Package: libopenmesh-apps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmesh1 (= ${binary:Version})
Description: Tools for representing and manipulating polygonal meshes
 OpenMesh is a generic and efficient data structure for representing and
 manipulating polygonal meshes. It was designed with the following goals in
 mind:
 .
 - Flexibility: provide a basis for many different algorithms without the need
 for adaptation.
 .
 - Efficiency: maximize time efficiency while keeping memory usage as low as
 possible.
 .
 - Ease of use: wrap complex internal structure in an easy-to-use interface.
 .
 OpenMesh provides the following features:
 .
 - Representation of arbitrary polygonal (the general case) and pure triangle
 meshes (providing more efficient, specialized algorithms)
 .
 - Explicit representation of vertices, halfedges, edges and faces.
 .
 - Fast neighborhood access, especially the one-ring neighborhood
 .
 - Highly customizable
 .
   - Choose your coordinate type (dimension and scalar type)
   - Attach user-defined elements/functions to the mesh elements.
   - Attach and check for attributes
   - Attach data at runtime using dynamic properties.
 .
 This package provides the executable tools

Package: libopenmesh-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Suggests: libopenmesh-dev (= ${binary:Version}), libopenmesh-apps (= ${binary:Version})
Description: Tools for representing and manipulating polygonal meshes
 OpenMesh is a generic and efficient data structure for representing and
 manipulating polygonal meshes. It was designed with the following goals in
 mind:
 .
 - Flexibility: provide a basis for many different algorithms without the need
 for adaptation.
 .
 - Efficiency: maximize time efficiency while keeping memory usage as low as
 possible.
 .
 - Ease of use: wrap complex internal structure in an easy-to-use interface.
 .
 OpenMesh provides the following features:
 .
 - Representation of arbitrary polygonal (the general case) and pure triangle
 meshes (providing more efficient, specialized algorithms)
 .
 - Explicit representation of vertices, halfedges, edges and faces.
 .
 - Fast neighborhood access, especially the one-ring neighborhood
 .
 - Highly customizable
 .
   - Choose your coordinate type (dimension and scalar type)
   - Attach user-defined elements/functions to the mesh elements.
   - Attach and check for attributes
   - Attach data at runtime using dynamic properties.
 .
 This package provides the HTML documentation

=== debian/watch ===
# I get the latest version from gitlab. BUT I grab the archive from the main
# site. Because that archive already has the cmake-library submodule

version=4
opts=filenamemangle=s/.*\/(\d\S+)\/archive\.tar\.gz/openmesh-$1\.tar\.gz/g,\
downloadurlmangle=s{.*OpenMesh-(\d\S+)\.tar\.gz}{https://www.graphics.rwth-aachen.de/media/openmesh_static/Releases/$1/OpenMesh-$1.tar.gz} \
  https://gitlab.vci.rwth-aachen.de:9000/OpenMesh/OpenMesh/tags?sort=updated_desc .*/archive/.*OpenMesh-(\d\S+)\.tar\.gz

## openmesh 10.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,14 +2,14 @@
 
 
 # Set and enforce C++-11 flags
-set( CMAKE_CXX_STANDARD_REQUIRED TRUE )
-set( CMAKE_CXX_STANDARD 11 )
+#set( CMAKE_CXX_STANDARD_REQUIRED TRUE )
+#set( CMAKE_CXX_STANDARD 11 )
 
 enable_testing()
 
 
 project (OpenMesh 
-         VERSION 9.0.0
+         VERSION 10.0.0
          LANGUAGES C CXX ) 
 
 # Set AUTO UIC/MOC Policy to new for CMAKE 3.17 or higher

=== src/Unittests/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,72 @@
 include (VCICommon)
 
-include_directories (
-  ..
-  ${CMAKE_CURRENT_SOURCE_DIR}
+set( UNITTEST_SRC
+unittests.cc
+unittests_add_face.cc
+unittests_boundary.cc
+unittests_centroid_calculations.cc
+unittests_convert_meshes.cc
+unittests_cpp_11_features.cc
+unittests_decimater.cc
+unittests_delete_face.cc
+unittests_eigen3_type.cc
+unittests_faceless_mesh.cc
+unittests_mc_decimater.cc
+unittests_mesh_cast.cc
+unittests_mesh_dual.cc
+unittests_mesh_type.cc
+unittests_mixed_decimater.cc
+unittests_normal_calculations.cc
+unittests_polymesh_collapse.cc
+unittests_polymesh_vec2i.cc
+unittests_property.cc
+unittests_propertymanager.cc
+unittests_randomNumberGenerator.cc
+unittests_read_write_OBJ.cc
+unittests_read_write_OFF.cc
+unittests_read_write_OM.cc
+unittests_read_write_PLY.cc
+unittests_read_write_STL.cc
+unittests_set_positions_directly.cc
+unittests_smart_handles.cc
+unittests_smart_ranges.cc
+unittests_smarttagger.cc
+unittests_smoother.cc
+unittests_split_copy.cc
+unittests_split_edge_copy.cc
+unittests_sr_binary.cc
+unittests_stripifier.cc
+unittests_subdivider_adaptive.cc
+unittests_subdivider_uniform.cc
+unittests_traits.cc
+unittests_trimesh_circulator_current_halfedge_handle_replacement.cc
+unittests_trimesh_circulator_edge_face.cc
+unittests_trimesh_circulator_edge_halfedge.cc
+unittests_trimesh_circulator_edge_vertex.cc
+unittests_trimesh_circulator_face_edge.cc
+unittests_trimesh_circulator_face_face.cc
+unittests_trimesh_circulator_face_halfedge.cc
+unittests_trimesh_circulator_face_vertex.cc
+unittests_trimesh_circulator_halfedge_loop.cc
+unittests_trimesh_circulator_vertex_edge.cc
+unittests_trimesh_circulator_vertex_face.cc
+unittests_trimesh_circulator_vertex_ihalfedge.cc
+unittests_trimesh_circulator_vertex_ohalfedge.cc
+unittests_trimesh_circulator_vertex_vertex.cc
+unittests_trimesh_collapse.cc
+unittests_trimesh_garbage_collection.cc
+unittests_trimesh_iterators.cc
+unittests_trimesh_navigation.cc
+unittests_trimesh_others.cc
+unittests_trimesh_ranges.cc
+unittests_trimesh_split.cc
+unittests_trimesh_vec2i.cc
+unittests_tutorials.cc
+unittests_vdpm.cc
+unittests_vector_type.cc
 )
+
+
 
 if ( NOT DEFINED OPENMESH_BUILD_UNIT_TESTS)
     set( OPENMESH_BUILD_UNIT_TESTS false CACHE BOOL "Enable or disable unit test builds in OpenMesh." )
@@ -35,7 +98,6 @@
     endif()
 
     # Create new target named unittests_hexmeshing
-    FILE(GLOB UNITTEST_SRC *.cc)
     # Create unittest executable
     vci_add_executable(unittests ${UNITTEST_SRC})
     vci_add_executable(unittests_customvec ${UNITTEST_SRC})

=== debian/changelog ===
openmesh (10.0.0-2) unstable; urgency=medium

  * Added missing #includes to fix FTBFS (Closes: #1067954)

 -- Dima Kogan <dkogan@debian.org>  Mon, 13 May 2024 11:12:16 -0700

openmesh (10.0.0-1) unstable; urgency=medium

  * New upstream release
  * Package ABI bump

 -- Dima Kogan <dkogan@debian.org>  Sat, 04 May 2024 08:37:05 -0700

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: openmesh
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
@@ -19,7 +18,7 @@
 Vcs-Git: https://salsa.debian.org/science-team/openmesh.git
 Vcs-Browser: https://salsa.debian.org/science-team/openmesh
 
-Package: libopenmesh1
+Package: libopenmesh10.0
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -60,7 +59,7 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmesh1 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmesh10.0 (= ${binary:Version}),
          libeigen3-dev,
          libopenscenegraph-dev
 Suggests: libopenmesh-doc, libopenmesh-apps
@@ -97,7 +96,7 @@
 
 Package: libopenmesh-apps
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmesh1 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libopenmesh10.0 (= ${binary:Version})
 Description: Tools for representing and manipulating polygonal meshes
  OpenMesh is a generic and efficient data structure for representing and
  manipulating polygonal meshes. It was designed with the following goals in
@@ -134,6 +133,7 @@
 Depends: ${misc:Depends}
 Section: doc
 Suggests: libopenmesh-dev (= ${binary:Version}), libopenmesh-apps (= ${binary:Version})
+Multi-Arch: foreign
 Description: Tools for representing and manipulating polygonal meshes
  OpenMesh is a generic and efficient data structure for representing and
  manipulating polygonal meshes. It was designed with the following goals in
